"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
Object.defineProperty(exports, "__esModule", { value: true });
var env_1 = __importDefault(require("../../utils/env"));
var baseOptions = {
    connectionLimit: 10,
    dateStrings: true
};
var DEV = {
    host: (_a = env_1.default.DB_HOST) !== null && _a !== void 0 ? _a : 'localhost',
    database: (_b = env_1.default.DB_DATABASE) !== null && _b !== void 0 ? _b : 'database',
    port: (_c = env_1.default.DB_PORT) !== null && _c !== void 0 ? _c : '5432',
    user: (_d = env_1.default.DB_USERNAME) !== null && _d !== void 0 ? _d : 'root',
    password: (_e = env_1.default.DB_PASSWORD) !== null && _e !== void 0 ? _e : 'password'
};
var PROD = {
    host: (_f = env_1.default.DB_HOST_PROD) !== null && _f !== void 0 ? _f : 'localhost',
    database: (_g = env_1.default.DB_DATABASE_PROD) !== null && _g !== void 0 ? _g : 'database',
    port: (_h = env_1.default.DB_PORT_PROD) !== null && _h !== void 0 ? _h : '5432',
    user: (_j = env_1.default.DB_USERNAME_PROD) !== null && _j !== void 0 ? _j : 'root',
    password: (_k = env_1.default.DB_PASSWORD_PROD) !== null && _k !== void 0 ? _k : 'password'
};
var options = {
    development: DEV,
    production: PROD
};
var config = __assign(__assign({}, baseOptions), options[env_1.default.NODE_ENV || 'development']);
exports.default = config;
