"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var connections_1 = __importDefault(require("../connections"));
var helper_1 = __importDefault(require("../utils/helper"));
var constant_1 = __importDefault(require("../utils/constant"));
var connections_2 = require("../connections");
var Abstract = /** @class */ (function () {
    function Abstract() {
        this.RESULT = null;
        this.TRANSACTION = null;
        this.REGISTRY = {};
        this.PLUCK = '';
        this.SAVE = '';
        this.DELETE = '';
        this.UPDATE = '';
        this.INSERT = '';
        this.SELECT = '';
        this.ONLY = [];
        this.EXCEPT = [];
        this.COUNT = '';
        this.FROM = '';
        this.JOIN = '';
        this.WHERE = '';
        this.GROUP_BY = '';
        this.ORDER_BY = '';
        this.LIMIT = '';
        this.HAVING = '';
        this.TABLE_NAME = '';
        this.TIMESTAMP = false;
        this.HIDDEN = [];
        this.PATTERN = constant_1.default.PATTERN.snake_case;
        this.CONNECTION = connections_1.default;
        this.CONSTANT = constant_1.default;
        this.DIALECT = connections_2.dialect;
        this.DEBUG = false;
        this.UUID = false;
        this.UUID_CUSTOM = '';
        this.HELPER = helper_1.default;
    }
    return Abstract;
}());
exports.default = Abstract;
