import Base from './Base';
declare class DB extends Base {
    static table(table: string): DB;
    static raw(sql: string): Promise<any[]>;
    raw(sql: string): Promise<any[]>;
    sensitive(column: string): string;
    table(table: string): this;
    static beginTransaction(): Promise<{
        rollback: () => Promise<boolean>;
        query: never[];
    }>;
    beginTransaction(): Promise<{
        rollback: () => Promise<boolean>;
        query: never[];
    }>;
}
export default DB;
