"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
var dotenv_1 = __importDefault(require("dotenv"));
dotenv_1.default.config();
var ENV = process.env;
var env = {
    NODE_ENV: (_a = ENV.NODE_ENV) !== null && _a !== void 0 ? _a : 'development',
    DB_DIALECT: ENV.DB_DIALECT,
    DB_USERNAME: ENV.DB_USERNAME,
    DB_PASSWORD: ENV.DB_PASSWORD,
    DB_DATABASE: ENV.DB_DATABASE,
    DB_HOST: ENV.DB_HOST,
    DB_PORT: ENV.DB_PORT,
    DB_DIALECT_PROD: ENV.DB_DIALECT_PROD,
    DB_USERNAME_PROD: ENV.DB_USERNAME_PROD,
    DB_PASSWORD_PROD: ENV.DB_PASSWORD_PROD,
    DB_DATABASE_PROD: ENV.DB_DATABASE_PROD,
    DB_HOST_PROD: ENV.DB_HOST_PROD,
    DB_PORT_PROD: ENV.DB_PORT_PROD,
};
exports.default = env;
