import DB from './DB';
import Model from './Model';
import Pool from '../connections';
import { Schema, Blueprint } from './Schema';
export { DB };
export { Model };
export { Pool };
export { Schema };
export { Blueprint };
declare const _default: {
    DB: typeof DB;
    Model: typeof Model;
    Pool: Promise<unknown>;
    Schema: typeof Schema;
    Blueprint: typeof Blueprint;
};
export default _default;
