"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var constant = {
    ID: 'ID',
    SHOW: 'SHOW',
    COLUMNS: 'COLUMNS',
    MYSQL: 'mysql',
    POSTGRESQL: 'pg',
    WHERE: 'WHERE',
    BETWEEN: 'BETWEEN',
    AND: 'AND',
    IS_NULL: 'IS NULL',
    IS_NOT_NULL: 'IS NOT NULL',
    OR: 'OR',
    LIKE: 'LIKE',
    SELECT: 'SELECT',
    FROM: 'FROM',
    STAR: 'STAR',
    OFFSET: 'OFFSET',
    GROUP_BY: 'GROUP BY',
    GROUP_CONCAT: 'GROUP_CONCAT',
    ORDER_BY: 'ORDER BY',
    DESC: 'DESC',
    ASC: 'ASC',
    INNER_JOIN: 'INNER JOIN',
    LEFT_JOIN: 'LEFT JOIN',
    RIGHT_JOIN: 'RIGHT JOIN',
    ON: 'ON',
    LIMIT: 'LIMIT',
    HAVING: 'HAVING',
    COUNT: 'COUNT',
    AVG: 'AVG',
    SUM: 'SUM',
    MAX: 'MAX',
    MIN: 'MIN',
    AS: 'AS',
    IN: 'IN',
    ALL: 'ALL',
    ANY: 'ANY',
    NOT_IN: 'NOT IN',
    SET: 'SET',
    NOT: 'NOT',
    DUPLICATE: 'DUPLICATE',
    KEY: 'KEY',
    WHERE_NOT_EXISTS: 'WHERE NOT EXISTS',
    EXISTS: 'EXISTS',
    VALUES: 'VALUES',
    UPDATE: 'UPDATE',
    DELETE: 'DELETE',
    INSERT: 'INSERT INTO',
    DROP_TABLE: 'DROP TABLE',
    RELATIONSHIP: {
        hasOne: 'hasOne',
        hasMany: 'hasMany',
        belongsTo: 'belongsTo',
        belongsToMany: 'belongsToMany'
    },
    RELATIONSHIP_CHILD: {
        hasOne: 'hasOne',
        hasMany: 'hasMany',
        belongsTo: 'belongsTo'
    },
    PATTERN: {
        snake_case: 'snake_case',
        camelCase: 'camelCase'
    }
};
exports.default = constant;
